<?php

declare(strict_types=1);

namespace App\Repository;

final class TblPreguntasCursoRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblPreguntasCursoId): object
    {
        $query = 'SELECT * FROM `TblPreguntasCurso` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasCursoId);
        $statement->execute();
        $TblPreguntasCurso = $statement->fetchObject();
        if (! $TblPreguntasCurso) {
            throw new \Exception('TblPreguntasCurso not found.', 404);
        }

        return $TblPreguntasCurso;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblPreguntasCurso` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblPreguntasCurso): object
    {
        $query = 'INSERT INTO `TblPreguntasCurso` (`Pregunta`, `TipoPregunta`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Pregunta, :TipoPregunta, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblPreguntasCurso->id);
//         $statement->bindParam('fecha', $TblPreguntasCurso->fecha);
        $statement->bindParam('Pregunta', $TblPreguntasCurso->Pregunta);
        $statement->bindParam('TipoPregunta', $TblPreguntasCurso->TipoPregunta);
        $statement->bindParam('field1', $TblPreguntasCurso->field1);
        $statement->bindParam('field2', $TblPreguntasCurso->field2);
        $statement->bindParam('field3', $TblPreguntasCurso->field3);
        $statement->bindParam('field4', $TblPreguntasCurso->field4);
        $statement->bindParam('field5', $TblPreguntasCurso->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblPreguntasCurso, object $data): object
    {
        if (isset($data->fecha)) {
            $TblPreguntasCurso->fecha = $data->fecha;
        }
        if (isset($data->Pregunta)) {
            $TblPreguntasCurso->Pregunta = $data->Pregunta;
        }
        if (isset($data->TipoPregunta)) {
            $TblPreguntasCurso->TipoPregunta = $data->TipoPregunta;
        }
        if (isset($data->field1)) {
            $TblPreguntasCurso->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblPreguntasCurso->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblPreguntasCurso->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblPreguntasCurso->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblPreguntasCurso->field5 = $data->field5;
        }

        $query = 'UPDATE `TblPreguntasCurso` SET `fecha` = :fecha, `Pregunta` = :Pregunta, `TipoPregunta` = :TipoPregunta, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasCurso->id);
        $statement->bindParam('fecha', $TblPreguntasCurso->fecha);
        $statement->bindParam('Pregunta', $TblPreguntasCurso->Pregunta);
        $statement->bindParam('TipoPregunta', $TblPreguntasCurso->TipoPregunta);
        $statement->bindParam('field1', $TblPreguntasCurso->field1);
        $statement->bindParam('field2', $TblPreguntasCurso->field2);
        $statement->bindParam('field3', $TblPreguntasCurso->field3);
        $statement->bindParam('field4', $TblPreguntasCurso->field4);
        $statement->bindParam('field5', $TblPreguntasCurso->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblPreguntasCurso->id);
    }

    public function delete(int $TblPreguntasCursoId): void
    {
        $query = 'DELETE FROM `TblPreguntasCurso` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasCursoId);
        $statement->execute();
    }
}
